﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace M63
{
    class Communication
    {
        private WebClient client;
        private string address;
        public int Id;
        public string[,] Map;
        public int Moves;
        public bool IsOpponent;
        public Person Me;
        public Person Opponent;
        //LogWindow log;

        public Communication(string ip)
        {
            //log = new LogWindow();
            //log.Show();
            this.client = new WebClient();
            this.address = ip;

            string str = this.client.DownloadString("http://" + this.address + "/start");
            //log.ShowMessage(str);
            this.Id = Int32.Parse(str.Split('\n')[0]);
            this.Moves = Int32.Parse(str.Split('\n')[1]);

            this.Map = new string[10, 10];
            for (int i = 0; i < 10; i++)
            {
                for (int j = 0; j < 20; j++)
                {
                    string tmp = str.Split('\n')[i + 2];
                    this.Map[i, j / 2] = str.Split('\n')[i + 2].Substring(j, 2);
                    j++;
                }
            }

            string[] line;
            if (str.Split('\n').Count() == 15)
            {
                IsOpponent = false;
            }
            else
            {
                IsOpponent = true;
                line = str.Split('\n')[13].Split(' ');
                Opponent = new Person(Int32.Parse(line[1]) - 1, Int32.Parse(line[0]) - 1, Int32.Parse(line[2]), Int32.Parse(line[3]));
            }

            line = str.Split('\n')[12].Split(' ');

            this.Me = new Person(Int32.Parse(line[1]) - 1, Int32.Parse(line[0]) - 1, Int32.Parse(line[2]), Int32.Parse(line[3]));
        }

        public void Go(string move)
        {
            switch (move)
            {
                case "L":
                    if (Me.Y - 1 < 0 || Map[Me.X, Me.Y - 1] == "XX") throw new Exception();
                    break;
                case "N":
                    if (Me.X - 1 < 0 || Map[Me.X - 1, Me.Y] == "XX") throw new Exception();
                    break;
                case "P":
                    if (Me.Y + 1 > 9 || Map[Me.X, Me.Y + 1] == "XX") throw new Exception();
                    break;
                case "D":
                    if (Me.X + 1 > 9 || Map[Me.X + 1, Me.Y] == "XX") throw new Exception();
                    break;
            }
            string str = this.client.DownloadString("http://" + this.address + "/tah?id=" + this.Id + "&pohyb=" + move);
            //log.ShowMessage(str);

            if (str.Contains("Konec"))
            {
                if (!IsOpponent)
                {
                    MessageBox.Show(String.Format("Konec hry! Získali jste {0} bodů.", Int32.Parse(str.Split(':')[1])));
                }
                else
                {
                    int ja = Int32.Parse(str.Split(':')[1].Split(' ')[1]);
                    int souper = Int32.Parse(str.Split(':')[1].Split(' ')[2]);
                    if (ja > souper) {
                        MessageBox.Show(String.Format("Vyhráli jste! Vaše skore: {0}. Skore soupeře: {1}.", ja, souper));
                    }
                    else {
                        MessageBox.Show(String.Format("Prohráli jste! Vaše skore: {0}. Skore soupeře: {1}.", ja, souper));
                    }
                }
                for (int i = 0; i < 10; i++)
                {
                    for (int j = 0; j < 10; j++)
                    {
                        this.Map[i, j] = "";
                        this.Me = null;
                    }
                }
            }
            else if (str.Contains("Chyba"))
            {
                MessageBox.Show(str);
                for (int i = 0; i < 10; i++)
                {
                    for (int j = 0; j < 10; j++)
                    {
                        this.Map[i, j] = "";
                        this.Me = null;
                    }
                }
            }
            else
            {

                this.Moves = Int32.Parse(str.Split('\n')[1]);

                for (int i = 0; i < 10; i++)
                {
                    for (int j = 0; j < 20; j++)
                    {
                        string tmp = str.Split('\n')[i + 2];
                        this.Map[i, j / 2] = str.Split('\n')[i + 2].Substring(j, 2);
                        j++;
                    }
                }

                string[] line;
                if (str.Split('\n').Count() == 15)
                {
                    IsOpponent = false;
                }
                else
                {
                    IsOpponent = true;
                    line = str.Split('\n')[13].Split(' ');
                    Opponent = new Person(Int32.Parse(line[1]) - 1, Int32.Parse(line[0]) - 1, Int32.Parse(line[2]), Int32.Parse(line[3]));
                }

                line = str.Split('\n')[12].Split(' ');

                this.Me = new Person(Int32.Parse(line[1]) - 1, Int32.Parse(line[0]) - 1, Int32.Parse(line[2]), Int32.Parse(line[3]));
            }
        }
    }
}
