﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace M63
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private Communication comm;
        ObservableCollection<ObservableCollection<string>> context;

        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                this.comm.Go("L");

                string[,] map = this.comm.Map;
                if (this.comm.Me != null)
                {
                    this.movesCount.Content = "Zbývající počet tahů: " + this.comm.Moves.ToString();
                    this.weight.Content = "Hodnota nákladu: " + this.comm.Me.Value.ToString();
                    this.totalWeight.Content = "Získáno nákladu: " + this.comm.Me.TotalValue.ToString();
                    map[this.comm.Me.X, this.comm.Me.Y] += " (hráč)";
                    if (comm.IsOpponent)
                    {
                        this.weightOp.Content = "Hodnota nákladu soupeře: " + this.comm.Opponent.Value.ToString();
                        this.totalWeightOp.Content = "Získáno nákladu soupeře: " + this.comm.Opponent.TotalValue.ToString();
                        map[this.comm.Opponent.X, this.comm.Opponent.Y] += " (PC)";
                    }
                }
                else
                {
                    this.id.Content = "Id hry:";
                    this.movesCount.Content = "Zbývající počet tahů:";
                    this.totalMovesCount.Content = "Celkový počet tahů:";
                    this.weight.Content = "Hodnota nákladu:";
                    this.totalWeight.Content = "Získáno nákladu:";
                    this.weightOp.Visibility = System.Windows.Visibility.Hidden;
                    this.totalWeightOp.Visibility = System.Windows.Visibility.Hidden;
                }
                for (int i = 0; i < 10; i++)
                {
                    for (int j = 0; j < 10; j++)
                    {
                        context[i][j] = map[i, j];
                    }
                }
            }
            catch
            {
                MessageBox.Show("Nepovolený tah!");
            }
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            try
            {
                this.comm.Go("N");

                string[,] map = this.comm.Map;
                if (this.comm.Me != null)
                {
                    this.movesCount.Content = "Zbývající počet tahů: " + this.comm.Moves.ToString();
                    this.weight.Content = "Hodnota nákladu: " + this.comm.Me.Value.ToString();
                    this.totalWeight.Content = "Získáno nákladu: " + this.comm.Me.TotalValue.ToString();
                    map[this.comm.Me.X, this.comm.Me.Y] += " (hráč)";
                    if (comm.IsOpponent)
                    {
                        this.weightOp.Content = "Hodnota nákladu soupeře: " + this.comm.Opponent.Value.ToString();
                        this.totalWeightOp.Content = "Získáno nákladu soupeře: " + this.comm.Opponent.TotalValue.ToString();
                        map[this.comm.Opponent.X, this.comm.Opponent.Y] += " (PC)";
                    }
                }
                else
                {
                    this.id.Content = "Id hry:";
                    this.movesCount.Content = "Zbývající počet tahů:";
                    this.totalMovesCount.Content = "Celkový počet tahů:";
                    this.weight.Content = "Hodnota nákladu:";
                    this.totalWeight.Content = "Získáno nákladu:";
                    this.weightOp.Visibility = System.Windows.Visibility.Hidden;
                    this.totalWeightOp.Visibility = System.Windows.Visibility.Hidden;
                }
                for (int i = 0; i < 10; i++)
                {
                    for (int j = 0; j < 10; j++)
                    {
                        context[i][j] = map[i, j];
                    }
                }
            }
            catch
            {
                MessageBox.Show("Nepovolený tah!");
            }
        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            try
            {
                this.comm.Go("P");

                string[,] map = this.comm.Map;
                if (this.comm.Me != null)
                {
                    this.movesCount.Content = "Zbývající počet tahů: " + this.comm.Moves.ToString();
                    this.weight.Content = "Hodnota nákladu: " + this.comm.Me.Value.ToString();
                    this.totalWeight.Content = "Získáno nákladu: " + this.comm.Me.TotalValue.ToString();
                    map[this.comm.Me.X, this.comm.Me.Y] += " (hráč)";
                    if (comm.IsOpponent)
                    {
                        this.weightOp.Content = "Hodnota nákladu soupeře: " + this.comm.Opponent.Value.ToString();
                        this.totalWeightOp.Content = "Získáno nákladu soupeře: " + this.comm.Opponent.TotalValue.ToString();
                        map[this.comm.Opponent.X, this.comm.Opponent.Y] += " (PC)";
                    }
                }
                else
                {
                    this.id.Content = "Id hry:";
                    this.movesCount.Content = "Zbývající počet tahů:";
                    this.totalMovesCount.Content = "Celkový počet tahů:";
                    this.weight.Content = "Hodnota nákladu:";
                    this.totalWeight.Content = "Získáno nákladu:";
                    this.weightOp.Visibility = System.Windows.Visibility.Hidden;
                    this.totalWeightOp.Visibility = System.Windows.Visibility.Hidden;
                }
                for (int i = 0; i < 10; i++)
                {
                    for (int j = 0; j < 10; j++)
                    {
                        context[i][j] = map[i, j];
                    }
                }
            }
            catch
            {
                MessageBox.Show("Nepovolený tah!");
            }
        }

        private void Button_Click_3(object sender, RoutedEventArgs e)
        {
            try
            {
                this.comm.Go("D");

                string[,] map = this.comm.Map;
                if (this.comm.Me != null)
                {
                    this.movesCount.Content = "Zbývající počet tahů: " + this.comm.Moves.ToString();
                    this.weight.Content = "Hodnota nákladu: " + this.comm.Me.Value.ToString();
                    this.totalWeight.Content = "Získáno nákladu: " + this.comm.Me.TotalValue.ToString();
                    map[this.comm.Me.X, this.comm.Me.Y] += " (hráč)";
                    if (comm.IsOpponent)
                    {
                        this.weightOp.Content = "Hodnota nákladu soupeře: " + this.comm.Opponent.Value.ToString();
                        this.totalWeightOp.Content = "Získáno nákladu soupeře: " + this.comm.Opponent.TotalValue.ToString();
                        map[this.comm.Opponent.X, this.comm.Opponent.Y] += " (PC)";
                    }
                }
                else
                {
                    this.id.Content = "Id hry:";
                    this.movesCount.Content = "Zbývající počet tahů:";
                    this.totalMovesCount.Content = "Celkový počet tahů:";
                    this.weight.Content = "Hodnota nákladu:";
                    this.totalWeight.Content = "Získáno nákladu:";
                    this.weightOp.Visibility = System.Windows.Visibility.Hidden;
                    this.totalWeightOp.Visibility = System.Windows.Visibility.Hidden;
                }
                for (int i = 0; i < 10; i++)
                {
                    for (int j = 0; j < 10; j++)
                    {
                        context[i][j] = map[i, j];
                    }
                }
            }
            catch
            {
                MessageBox.Show("Nepovolený tah!");
            }
        }

        private void Button_Click_4(object sender, RoutedEventArgs e)
        {
            this.comm = new Communication(this.ip.Text);
            this.id.Content = "Id hry: " + this.comm.Id.ToString();
            this.movesCount.Content = "Zbývající počet tahů: " + this.comm.Moves.ToString();
            this.totalMovesCount.Content = "Celkový počet tahů: " + this.comm.Moves.ToString();
            this.weight.Content = "Hodnota nákladu: " + this.comm.Me.Value.ToString();
            this.totalWeight.Content = "Získáno nákladu: " + this.comm.Me.TotalValue.ToString();

            string[,] map = this.comm.Map;
            map[this.comm.Me.X, this.comm.Me.Y] += " (hráč)";
            if (comm.IsOpponent)
            {
                weightOp.Visibility = System.Windows.Visibility.Visible;
                totalWeightOp.Visibility = System.Windows.Visibility.Visible;
                map[this.comm.Opponent.X, this.comm.Opponent.Y] += " (PC)";
                this.weightOp.Content = "Hodnota nákladu soupeře: " + this.comm.Opponent.Value.ToString();
                this.totalWeightOp.Content = "Získáno nákladu soupeře: " + this.comm.Opponent.TotalValue.ToString();
            }
            else
            {
                weightOp.Visibility = System.Windows.Visibility.Hidden;
                totalWeightOp.Visibility = System.Windows.Visibility.Hidden;
            }
            this.context = new ObservableCollection<ObservableCollection<string>>();

            for (int i = 0; i < 10; i++)
            {
                this.context.Add(new ObservableCollection<string>());
                for (int j = 0; j < 10; j++)
                {
                    this.context[i].Add(map[i, j]);
                }
            }
            this.DataContext = context;
        }

        private void Window_KeyDown(object sender, KeyEventArgs e)
        {
            switch (e.Key)
            {
                case Key.Left:
                    Button_Click(null, null);
                    e.Handled = true;
                    break;
                case Key.Up:
                    Button_Click_1(null, null);
                    e.Handled = true;
                    break;
                case Key.Right:
                    Button_Click_2(null, null);
                    e.Handled = true;
                    break;
                case Key.Down:
                    Button_Click_3(null, null);
                    e.Handled = true;
                    break;
            };
        }
    }
}
